<?php
/**
 * Zend Framework (http://framework.zend.com/)
 *
 * @link      http://github.com/zendframework/ZendSkeletonApplication for the canonical source repository
 * @copyright Copyright (c) 2005-2015 Zend Technologies USA Inc. (http://www.zend.com)
 * @license   http://framework.zend.com/license/new-bsd New BSD License
 */

namespace Application;

return array(

	'session' => array(
        'remember_me_seconds' => 86400,// 1 Day
        'gc_maxlifetime' => 86400,
        'cookie_lifetime' => 86400,
        'use_cookies' => true,
        'cookie_httponly' => true
    ),
	
    'router' => array(
        'routes' => array(
            'home' => array(
                'type' => 'Zend\Mvc\Router\Http\Literal',
                'options' => array(
                    'route'    => '/',
                    'defaults' => array(
                        'controller' => 'Application\Controller\Index',
                        'action'     => 'index',
                    ),
                ),
            ),
            // The following is a route to simplify getting started creating
            // new controllers and actions without needing to create a new
            // module. Simply drop new controllers in, and you can access them
            // using the path /application/:controller/:action
            'application' => array(
                'type'    => 'Literal',
                'options' => array(
                    'route'    => '/',  // '/application',
                    'defaults' => array(
                        '__NAMESPACE__' => 'Application\Controller',
                        'controller'    => 'Index',
                        'action'        => 'index',
                    ),
                ),
                'may_terminate' => true,
                'child_routes' => array(
                    'default' => array(
                        'type'    => 'Segment',
                        'options' => array(
                            'route'    => '/[:controller[/:action]]',
                            'constraints' => array(
                                'controller' => '[a-zA-Z][a-zA-Z0-9_-]*',
                                'action'     => '[a-zA-Z][a-zA-Z0-9_-]*',
                            ),
                            'defaults' => array(
                            ),
                        ),
                    ),
                ),
            ),
			
			
			
			
			/*Para crear un Controller nuevo -> Copiar desde aqui*/
			'Login' => array(// <-- Nombre del controlador
				'type'    => 'segment',
				'options' => array(
					'route'    => '/login[/:action]',
					'constraints' => array(
						'action' => '[a-zA-Z][a-zA-Z0-9_-]*'
					),
					'defaults' => array(
						'controller' => 'Application\Controller\Login',
						'action'     => 'index',
					),
				),
			),
			/*Hasta aqui y configurar al gusto*/
			
			/*Para crear un Controller nuevo -> Copiar desde aqui*/
			'Dashboard' => array(// <-- Nombre del controlador
				'type'    => 'segment',
				'options' => array(
					'route'    => '/dashboard[/:action]',
					'constraints' => array(
						'action' => '[a-zA-Z][a-zA-Z0-9_-]*'
					),
					'defaults' => array(
						'controller' => 'Application\Controller\Dashboard',
						'action'     => 'index',
					),
				),
			),
			/*Hasta aqui y configurar al gusto*/


			/*Para crear un Controller nuevo -> Copiar desde aqui*/
			'Cron' => array(// <-- Nombre del controlador
				'type'    => 'segment',
				'options' => array(
					'route'    => '/cron[/:action]',
					'constraints' => array(
						'action' => '[a-zA-Z][a-zA-Z0-9_-]*'
					),
					'defaults' => array(
						'controller' => 'Application\Controller\Cron',
						'action'     => 'index',
					),
				),
			),
			/*Hasta aqui y configurar al gusto*/
			
			/*Para crear un Controller nuevo -> Copiar desde aqui*/
			'Api' => array(// <-- Nombre del controlador
				'type'    => 'segment',
				'options' => array(
					'route'    => '/api[/:action]',
					'constraints' => array(
						'action' => '[a-zA-Z][a-zA-Z0-9_-]*'
					),
					'defaults' => array(
						'controller' => 'Application\Controller\Api',
						'action'     => 'index',
					),
				),
			),
			/*Hasta aqui y configurar al gusto*/

            /*Para crear un Controller nuevo -> Copiar desde aqui*/
            'Request' => array(// <-- Nombre del controlador
                'type'    => 'segment',
                'options' => array(
                    'route'    => '/request[/:action]',
                    'constraints' => array(
                        'action' => '[a-zA-Z][a-zA-Z0-9_-]*'
                    ),
                    'defaults' => array(
                        'controller' => 'Application\Controller\Request',
                        'action'     => 'index',
                    ),
                ),
            ),
            /*Hasta aqui y configurar al gusto*/

            /*Para crear un Controller nuevo -> Copiar desde aqui*/
            'Landing' => array(// <-- Nombre del controlador
                'type'    => 'segment',
                'options' => array(
                    'route'    => '/landing[/:action][/:slashParams][/:creation]',
                    'constraints' => array(
                        'action' => '[a-zA-Z][a-zA-Z0-9_-]*',
						'slashParams' => '[a-zA-Z][a-zA-Z0-9_\/-]*',
						'creation' => '[a-zA-Z][a-zA-Z0-9_\/-]*'
                    ),
                    'defaults' => array(
                        'controller' => 'Application\Controller\Landing',
                        'action'     => 'index',
                    ),
                ),
            ),
            /*Hasta aqui y configurar al gusto*/
			
            
			/*Para crear un Controller nuevo -> Copiar desde aqui*/
			'Test' => array(// <-- Nombre del controlador
				'type'    => 'segment',
				'options' => array(
					'route'    => '/test[/:action]',
					'constraints' => array(
						'action' => '[a-zA-Z][a-zA-Z0-9_-]*'
					),
					'defaults' => array(
						'controller' => 'Application\Controller\Test',
						'action'     => 'index',
					),
				),
			),
			/*Hasta aqui y configurar al gusto*/

            /*Para crear un Controller nuevo -> Copiar desde aqui*/
            'Permissions' => array(// <-- Nombre del controlador
                'type'    => 'segment',
                'options' => array(
                    'route'    => '/permissions[/:action]',
                    'constraints' => array(
                        'action' => '[a-zA-Z][a-zA-Z0-9_-]*'
                    ),
                    'defaults' => array(
                        'controller' => 'Application\Controller\Permissions',
                        'action'     => 'index',
                    ),
                ),
            ),
            /*Hasta aqui y configurar al gusto*/
			
        ),
    ),




    'service_manager' => array(
        'abstract_factories' => array(
            'Zend\Cache\Service\StorageCacheAbstractServiceFactory',
            'Zend\Log\LoggerAbstractServiceFactory',
        ),
        'factories' => array(
            'translator' => 'Zend\Mvc\Service\TranslatorServiceFactory',
        ),
    ),
    'translator' => array(
        'locale' => 'en_US',
        'translation_file_patterns' => array(
            array(
                'type'     => 'gettext',
                'base_dir' => __DIR__ . '/../language',
                'pattern'  => '%s.mo',
            ),
        ),
    ),
	
	
	
    'service_manager' => array(
        'abstract_factories' => array(
            'Zend\Cache\Service\StorageCacheAbstractServiceFactory',
            'Zend\Log\LoggerAbstractServiceFactory',
        ),
        'factories' => array(
            'translator' => 'Zend\Mvc\Service\TranslatorServiceFactory',
			
			
			'Application/Model/Dbquery' => function($sm){

				$dbAdapter = $sm->get('Zend\Db\Adapter\Adapter');

				$config = $sm->get('Config');
				
				$tools = new \Application\Plugin\Tools($config);
				$dbquery = new \Application\Model\Dbquery($dbAdapter, $config, $tools);// Inyectando el adaptador a DB a la clase Dbquery
				//$dbquery->setDbAdapter($dbAdapter);
				return $dbquery;

			},
			'Application/Model/Landing' => function($sm){
				$dbAdapter = $sm->get('Zend\Db\Adapter\Adapter');
				$config = $sm->get('Config');
				$landing = new \Application\Model\Landing($sm);
				//$landing->setDbAdapter($dbAdapter);
				return $landing;
			},
			
			'Tools' => 'Application\Plugin\Tools',
            'Datehelper' => 'Application\Plugin\DateHelper',
        ),
    ),
    'translator' => array(
        'locale' => 'en_US',
        'translation_file_patterns' => array(
            array(
                'type'     => 'gettext',
                'base_dir' => __DIR__ . '/../language',
                'pattern'  => '%s.mo',
            ),
        ),
    ),
	
	
	
	
    'controllers' => array(
        'invokables' => array(
            'Application\Controller\Index'     => Controller\IndexController::class,
            'Application\Controller\Login'     => Controller\LoginController::class,
            'Application\Controller\Dashboard' => Controller\DashboardController::class,
            'Application\Controller\Test' => Controller\TestController::class,
            'Application\Controller\Api' => Controller\ApiController::class,
			'Application\Controller\Request' => Controller\RequestController::class,
            'Application\Controller\Cron' => Controller\CronController::class,
            'Application\Controller\Landing' => Controller\LandingController::class,
            'Application\Controller\Permissions' => Controller\PermissionsController::class,

        ),
    ),
    'view_manager' => array(
        'display_not_found_reason' => true,
        'display_exceptions'       => true,
        'doctype'                  => 'HTML5',
        'not_found_template'       => 'error/404',
        'exception_template'       => 'error/index',
        'template_map' => array(
            'layout/layout'           => __DIR__ . '/../view/layout/layout.phtml',
            'application/index/index' => __DIR__ . '/../view/application/index/index.phtml',
            'error/404'               => __DIR__ . '/../view/error/404.phtml',
            'error/index'             => __DIR__ . '/../view/error/index.phtml',
        ),
        'template_path_stack' => array(
            __DIR__ . '/../view',
        ),
		'strategies' => array(
            'ViewJsonStrategy',
        )
    ),
    // Placeholder for console routes
    
	/*'console' => array(
        'router' => array(
            'routes' => array(
            ),
        ),
    ),*/


	'controller_plugins' => array(
        'invokables' => array(
            'Tools' => 'Application\Plugin\Tools',
            'Datehelper' => 'Application\Plugin\DateHelper',
        )
    ),

    'console' => array(
        'router' => array(
            'routes' => array(
                'Cron' => array(
                    'options' => array(
                        'route'    => 'cron (test|test2):task',
                        'defaults' => array(
                            'controller' => 'Application\Controller\Cron',
                            'action' => 'index'
                        ),
                    ),
                ),
            ),
        ),
    ),

);
