<?php
/**
 * Zend Framework (http://framework.zend.com/)
 *
 * @link      http://github.com/zendframework/ZendSkeletonApplication for the canonical source repository
 * @copyright Copyright (c) 2005-2015 Zend Technologies USA Inc. (http://www.zend.com)
 * @license   http://framework.zend.com/license/new-bsd New BSD License
 */

namespace Application\Controller;

use Zend\Mvc\Controller\AbstractActionController;
use Zend\View\Model\ViewModel;
use Zend\Session\Container;

class DashboardController extends AbstractActionController
{

	public function indexAction(){
		
		$varsToView = array();
		$varsToView["loggedIn"] = false;
		$varsToView["tools"] = $this->Tools();
		$reqParams = $this->getRequest()->getQuery();
		$varsToView["reqParams"] = $reqParams;
		
		$userSessionAuth = new Container('userSessionAuth');
		
		if($userSessionAuth->offsetExists('loggedIn')){
			$this->layout('layout/dashboard');
			
		}else{
			
			$varsToView["loggedIn"] = false;
			return $this->redirect()->toRoute('application');
		}
		$viewModel = new ViewModel($varsToView);
		return $viewModel;

	}	

	public function pageAction(){
		
		$varsToView = array();
		$varsToView["loggedIn"] = false;
		$varsToView["tools"] = $this->Tools();
		$reqParams = $this->getRequest()->getQuery();
		$varsToView["reqParams"] = $reqParams;
		
		//$userSessionAuth = new Container('userSessionAuth');
		
		//if($userSessionAuth->offsetExists('loggedIn')){
			$this->layout('layout/default');
			
		//}else{
			
			//$varsToView["loggedIn"] = false;
			//return $this->redirect()->toRoute('application');
		//}
		$viewModel = new ViewModel($varsToView);
		return $viewModel;

	}	

}
