<?php
/**
 * Zend Framework (http://framework.zend.com/)
 *
 * @link      http://github.com/zendframework/ZendSkeletonApplication for the canonical source repository
 * @copyright Copyright (c) 2005-2015 Zend Technologies USA Inc. (http://www.zend.com)
 * @license   http://framework.zend.com/license/new-bsd New BSD License
 */

namespace Application\Controller;

use Zend\Mvc\Controller\AbstractActionController;
use Zend\View\Model\ViewModel;
use Zend\Session\Container;

class IndexController extends AbstractActionController
{
    public function indexAction()
    {
		$this->layout('layout/login');
		
		$varsToView = array();
		$varsToView["error"] = false;
		$userSessionAuth = new Container('userSessionAuth');
		
		if(!$userSessionAuth->offsetExists('loggedIn')){// Valida si hay session
			//echo '<br>no hay session';
			if($this->getRequest()->isPost()){//Si viene por post
				if($this->getRequest()->getPost('username') && $this->getRequest()->getPost('username') !== '' 
					&& $this->getRequest()->getPost('password') && $this->getRequest()->getPost('password') !== ''){// Valida si existen username  y pass
					
					$username = strtolower($this->getRequest()->getPost('username'));
					$password = $this->getRequest()->getPost('password');
					
					$emailValidator = new \Zend\Validator\EmailAddress();
					if ($emailValidator->isValid($username)) {//Valida si el username es valido
						
						$dbquery = $this->getServiceLocator()->get('Application/Model/Dbquery');
						
						$userExist = $dbquery->login($username, $password);
						
						//Debug::dump($userExist);
						
						if($userExist){// Validamos si existe en la DB
							
							$userSessionAuth->offsetSet('loggedIn', true);
							$userSessionAuth->offsetSet('userBasicInfo', $userExist);
							$userSessionAuth->offsetSet('users_id', $userExist[0]["users_id"]);
							$userSessionAuth->offsetSet('users_fullname', $userExist[0]["users_fullname"]);
							$userSessionAuth->offsetSet('users_email', $userExist[0]["users_email"]);
							$userSessionAuth->offsetSet('open_menu', false);
                            $userSessionAuth->offsetSet('users_avatar', $userExist[0]["users_avatar"]);
							
							//Get permissions
							$usersTable = $this->getServiceLocator()->get('Application/Model/usersTable');
							$permissions = $usersTable->getUserPermissions($userExist[0]["users_id"]);
							
							$userSessionAuth->offsetSet('permissions', (count($permissions)>0?$permissions:array()));
							
							//return $this->redirect()->toRoute( 'application');
							return $this->redirect()->toRoute('Landing',
								array('controller'=>"Landing",
									'action' => "list"
								)

							);
							
						}else{
							
							$varsToView["error"] = true;
							$varsToView["message"] = "no registrado";
							//echo '<br>usuario no esta en db';
						}
						
						//echo '<br>email valido';
					}else{
						
						$varsToView["error"] = true;
						$varsToView["message"] = "email invalido";
						//echo '<br>email invalido';
					}
					
					
					
				}else{
					$varsToView["error"] = true;
					$varsToView["message"] = "faltan parametros";
				}
				
				
			}else{
				$varsToView["error"] = false;
				$varsToView["message"] = "No es post";
			}
			
		}else{
			
			return $this->redirect()->toRoute('Dashboard');
			
			die("sesion");
		}
		
		return new ViewModel($varsToView);
		
		
    }
}
