<?php
/**
 * Zend Framework (http://framework.zend.com/)
 *
 * @link      http://github.com/zendframework/ZendSkeletonApplication for the canonical source repository
 * @copyright Copyright (c) 2005-2015 Zend Technologies USA Inc. (http://www.zend.com)
 * @license   http://framework.zend.com/license/new-bsd New BSD License
 */

namespace Application\Controller;

use Zend\Mvc\Controller\AbstractActionController;
use Zend\View\Model\ViewModel;
use Zend\Session\Container;

class LoginController extends AbstractActionController
{

	public function salirAction(){
		
		$userSessionAuth = new Container('userSessionAuth');
		$userSessionAuth->getManager()->getStorage()->clear('userSessionAuth');
		
		$userImages = new Container('userImages');
		$userImages->getManager()->getStorage()->clear('userImages');
		
		return $this->redirect()->toRoute('application');

	}
    
     public function changestatusmenuAction(){
        $varsToView = array();
        $response = array(
            'response' => false,
            'message'  => 'Cambio no exitoso',
            'content'  => ''
        );

        $userSessionAuth = new Container('userSessionAuth');
        if($userSessionAuth->offsetExists('loggedIn')){
            $openmenu = $userSessionAuth->offsetGet('open_menu');
            $userSessionAuth->offsetSet('open_menu', !$openmenu);
            $response["response"] = true;
            $response["message"] = 'Cambio exitoso';
            $response["content"] = $userSessionAuth->offsetGet('open_menu');
        }else{
            $response["response"] = false;
            return $this->redirect()->toRoute('application');
        }
        
        $varsToView["resultJson"] = \Zend\Json\Json::encode($response);
        $viewModel = new ViewModel($varsToView);
        $viewModel->setTemplate('application/ajax/response');
        $viewModel->setTerminal(true);
        return $viewModel;
    }
}
