<?php
/**
 * Zend Framework (http://framework.zend.com/)
 *
 * @link      http://github.com/zendframework/ZendSkeletonApplication for the canonical source repository
 * @copyright Copyright (c) 2005-2012 Zend Technologies USA Inc. (http://www.zend.com)
 * @license   http://framework.zend.com/license/new-bsd New BSD License
 */

namespace Application\Controller;

use Zend\Mvc\Controller\AbstractActionController;
use Zend\View\Model\ViewModel;
use Zend\Session\Container;
use Zend\Debug\Debug;

class PermissionsController extends AbstractActionController
{
	private $config;
	
	public function __construct()
	{
		
		
		
	}
	
    public function indexAction()
    {
		return $this->redirect()->toRoute('application');
		$this->layout('layout/dashboard');
		$varsToView = array();
		$varsToView["error"] = true;
		$userSessionAuth = new Container('userSessionAuth');
		
		if($userSessionAuth->offsetExists('loggedIn')){// Valida si hay session
			
			
		}else{
			
			return $this->redirect()->toRoute('application');
		}
		
		//echo 'loggedIn:'.$userSessionAuth->offsetExists('loggedIn');
		
		
		return new ViewModel(array(
			'logged'=> $userSessionAuth->offsetExists('loggedIn'),
			'error'=> $varsToView["error"]
			
		));
	}
	
	public function userAction(){
		
		
		if(!$this->Tools()->hasAccess('web_permissions_user')){
			return $this->redirect()->toRoute('application');
		}
		
		
        $varsToView = array();        
        $userSessionAuth = new Container('userSessionAuth');
		
        if($userSessionAuth->offsetExists('loggedIn')){ 
            $this->layout('layout/default');
			$varsToView["user"] = array();
			$reqPost = $this->getRequest()->getPost();
			$reqParams = $this->getRequest()->getQuery();
			$usersTable = $this->getServiceLocator()->get('Application/Model/usersTable');
			
            
			$activeRoles = $usersTable->getActiveRoles();
			$varsToView["activeRoles"] = $activeRoles;
            
			//Debug::dump($reqParams);
			//Debug::dump($reqPost);
			if(isset($reqPost["va_users_id"])){
				
				if(isset($reqPost["va_users_pass_repeat_edited"]) && $reqPost["users_pass_repeat_edited"]!==''){
					$pass = $reqPost["va_users_pass_repeat_edited"];
				}else{
					$pass = '';
				}
				
				$data = array(
					'va_users_id'			=> $reqPost["va_users_id"],
					'va_roles_id'			=> $reqPost["va_roles_id"],
					//'va_floristrates_id'	=> ($reqPost['va_floristrates_id']==''? NULL :$reqPost['va_floristrates_id']),
					'va_users_fullname'		=> $reqPost["va_users_fullname"],
					'va_users_password'		=> $pass,
					'va_users_email'		=> $reqPost["va_users_email"],
					'va_users_status'		=> (isset($reqPost['va_users_status'])?1:0)
				);
				
				$updateUser = $usersTable->setUser($data);
				
				if($updateUser){
					$varsToView["msg"] = 'Usuario actualizado correctamente';
				}else{
					$varsToView["msg"] = 'Usuario no actualizado';
				}
				
			}else if(isset($reqParams["userId"])){
				$user = $usersTable->getUser($reqParams["userId"]);
				$varsToView["user"] = $user;
				//Debug::dump($user);
				
			}else if(  isset($reqPost['va_users_fullname']) && $reqPost['va_users_name']!==''
					&& isset($reqPost['va_users_email']) && $reqPost['va_users_email']!==''
					&& isset($reqPost['va_users_pass_repeat']) && $reqPost['va_users_pass_repeat']!==''
					&& isset($reqPost['va_roles_id']) && $reqPost['va_roles_id']!==''
			)
			{
				$data = array(
					'va_roles_id'			=> $reqPost["va_roles_id"],
                    //'va_floristrates_id'	=> ($reqPost['va_floristrates_id']==''? NULL :$reqPost['va_floristrates_id']),
					'va_users_fullname'		=> $reqPost["va_users_fullname"],
					'va_users_password'		=> $reqPost["va_users_pass_repeat"],
					'va_users_email'		=> $reqPost["va_users_email"],
					'va_users_status'		=> 1
				);

				$userId = $usersTable->setUser($data);
				
				if($userId){
					$varsToView["msg"] = 'Usuario creado correctamente';
				}else{
					$varsToView["msg"] = 'Usuario no creado';
				}
			}
			

            $varsToView['message'] = $userSessionAuth->offsetGet('message');
			$allUsers = $usersTable->getAllUsers();
			//Debug::dump($allUsers);
			$varsToView["allUsers"] = $allUsers;
			
        }else{
			$varsToView["activeRoles"] = array();
			$varsToView["activeRates"] = array();
            $varsToView["loggedIn"] = false;
            return $this->redirect()->toRoute('application');
        }

        //Limpiar variable de sesion message
        $userSessionAuth->offsetUnset('message');

        $viewModel = new ViewModel($varsToView);
        return $viewModel;
    }
	
	public function roleAction()
	{
		if(!$this->Tools()->hasAccess('web_permissions_role')){
			return $this->redirect()->toRoute('application');
		}
		$this->layout('layout/default');
		$varsToView = array();
		
		$userSessionAuth = new Container('userSessionAuth');
		if($userSessionAuth->offsetExists('loggedIn')){// Valida si hay session
			$reqParams = $this->getRequest()->getPost();
			
			$usersTable = $this->getServiceLocator()->get('Application/Model/usersTable');
			
			if(isset($reqParams['va_roles_name']) && $reqParams['va_roles_name']!==''){
				$roleId = $usersTable->setRole($reqParams['va_roles_name']);
				//Debug::dump($roleId);
				if($roleId){
					$varsToView["msg"] = 'Perfil creado correctamente';
				}else{
					$varsToView["msg"] = 'Perfil no creado';
				}
			}
			
			//Debug::dump($reqParams);
			$roles = $usersTable->getRoles();
			//Debug::dump($roles);
			$varsToView["roles"] = $roles;
		}else{
			$varsToView["roles"] = array();
			return $this->redirect()->toRoute('application');
		}
		
		$varsToView["logged"] = $userSessionAuth->offsetExists('loggedIn');
		
		return new ViewModel($varsToView);
	}
	
	
	
	public function editpermissionsAction()
	{
		$this->layout('layout/dashboard');
		$varsToView = array();
		
		$userSessionAuth = new Container('userSessionAuth');
		if($userSessionAuth->offsetExists('loggedIn')){// Valida si hay session
			$reqParams = $this->getRequest()->getQuery();
			$reqPost = $this->getRequest()->getPost();
			$usersTable = $this->getServiceLocator()->get('Application/Model/usersTable');
			$varsToView["tools"] = $this->Tools();
			
			//Debug::dump($reqPost);
			if(isset($reqPost['roleId']) && $reqPost['roleId']!==''){
				
				//echo '<br><br>editamos....';
				
				$enabledRolePermissions = $usersTable->disableEntireRolePermissionsById($reqPost['roleId']);
				
				$updateRole = $usersTable->updateRole($reqPost['roleId'], $reqPost['va_roles_name'], (isset($reqPost['va_roles_status'])?1:0));
				//insertamos los nuevos
				
				if(isset($reqPost['ruleId'])){
					//Debug::dump($reqPost['ruleId']);
					foreach($reqPost['ruleId'] as $key => $value){
						//Debug::dump($reqPost['roleId'].$key);
						$usersTable->setRolePermission($reqPost['roleId'], $key);
						
					}
				}
				
				$varsToView["msg"] = 'Permisos guardados correctamente';
				
				
			}
			if(isset($reqParams['roleId']) && $reqParams['roleId']!==''){
				$varsToView["roleId"] = $reqParams['roleId'];
				
				$role = $usersTable->getRoleById($reqParams['roleId']);
				$varsToView["va_roles_name"] = $role[0]['va_roles_name'];
				$varsToView["va_roles_status"] = $role[0]['va_roles_status'];
				
				$rules = $usersTable->getRules();
				$varsToView["rules"] = $rules;
				
				//Debug::dump($rules);
				
				
				$rolePermissions = $usersTable->getRolePermissionsById($reqParams['roleId']);
				$varsToView["rolePermissions"] = $rolePermissions;
				//Debug::dump($rolePermissions);
				
			}else{
				//redirect
				return $this->redirect()->toRoute('Dashboard');
			}
			
			//Debug::dump($reqParams);
			
		}else{
			$varsToView["roles"] = array();
			return $this->redirect()->toRoute('application');
		}
		
		$varsToView["logged"] = $userSessionAuth->offsetExists('loggedIn');
		
		return new ViewModel($varsToView);
	}
	
	
	public function userlistjsonAction()
	{
		$varsToView = array();
		$arrayReturn = array();
		$userSessionAuth = new Container('userSessionAuth');
		if($userSessionAuth->offsetExists('loggedIn')){// Valida si hay session
			
			$dbquery = $this->getServiceLocator()->get('Application/Model/Dbquery');
			$userlistjason = $dbquery->getAllUsersListJson();
			
			for($i=0;$i<count($userlistjason);$i++){
				$arrayReturn[] = array(
				"value" => $userlistjason[$i]["users_id"],
				"label" => $userlistjason[$i]["users_name"]);
			}
			
		}else{
			
			return $this->redirect()->toRoute('application');
		}
		
		//Debug::dump($userlistjason);
		
		$arrJson = $arrayReturn;
		
		$varsToView["resultJson"] = \Zend\Json\Json::encode($arrJson);
		$viewModel = new ViewModel($varsToView);
		$viewModel->setTerminal(true);//Este quita header y footer (layout -> home.phtml)
		return $viewModel;
	}
	
}
