<?php
/**
 * Zend Framework (http://framework.zend.com/)
 *
 * @link      http://github.com/zendframework/ZendSkeletonApplication for the canonical source repository
 * @copyright Copyright (c) 2005-2015 Zend Technologies USA Inc. (http://www.zend.com)
 * @license   http://framework.zend.com/license/new-bsd New BSD License
 */

namespace Application\Controller;

use Zend\Mvc\Controller\AbstractActionController;
use Zend\View\Model\ViewModel;
use Zend\Session\Container;

class RequestController extends AbstractActionController
{

	public function indexAction(){
		
		$varsToView = array();
		$varsToView["dateHelper"] = $this->DateHelper();
		
		$userSessionAuth = new Container('userSessionAuth');
		
		if($userSessionAuth->offsetExists('loggedIn')){
			$this->layout('layout/default');
			$this->layout()->setVariable('pageTitle', 'Book de Eventos');

			$requestModel = $this->getServiceLocator()->get('Application/Model/RequestTable');
			$varsToView['requests'] = $requestModel->getRequestsByDate();

		}else{
			$varsToView["loggedIn"] = false;
			return $this->redirect()->toRoute('application');
		}
		$viewModel = new ViewModel($varsToView);
		return $viewModel;

	}

}
