<?php 
namespace Application\Model;


use Zend\Db\TableGateway\TableGateway;


class CustomerTable
{
    protected $tableGateway;

    //https://framework.zend.com/manual/2.0/en/user-guide/database-and-models.html
    //Aca la documentación para ejemplos
    public function __construct(TableGateway $tableGateway)
    {
        $this->tableGateway = $tableGateway;
    }


    public function fetchAll()
    {
        $resultSet = $this->tableGateway->select();
        return $resultSet;
    }

    public function save($_data)
    {
        if (!isset($_data["va_customer_id"])) {
            $this->tableGateway->insert($_data);
            return $this->tableGateway->lastInsertValue;
            
        } else {
            /*if ($this->getOrder($_data["nj_orders_id"])) {
                return $this->tableGateway->update($_data, array('nj_orders_id' => $_data["nj_orders_id"]));
            } else {
                throw new \Exception('Order nj_orders_id does not exist');
            }*/
            return false;
        }
        
    }

    /**
    * Return Int //Afected rows total
    */
    public function update($data, $conditions){
        if(!is_array($conditions)){
            return 0;
        }
        return $this->tableGateway->update($data, $conditions);
    }

    
     /**
    * Retorna los datos del cliente
    * @param String $email
    * @return array
    */
    public function getCustomerById($customerId){
        $sql = 'SELECT 
                c.va_customer_id ,
                c.va_customer_name,
                c.va_customer_lastname,
                c.va_customer_secondlastname,
                c.va_customer_email,
                c.va_customer_phone,
                c.va_customer_code
            FROM `va_customer` c 
            WHERE c.va_customer_id = "'.$customerId.'"
                AND c.va_customer_status = 1
        ';

        $rs = $this->tableGateway->getAdapter()->driver->getConnection()->execute($sql);
        
        return $rs->current();
    }


    /**
    * Retorna si ya esta el customer registrado
    * @param String $email
    * @return array
    */
    public function customerExist($email){
        $sql = '
            SELECT COUNT(*) AS exist
            FROM `va_customer` c 
            WHERE c.va_customer_email = "'.$email.'"
                AND c.va_customer_status = 1
        ';

        $rs = $this->tableGateway->getAdapter()->driver->getConnection()->execute($sql);
        $customerExist = $rs->current();
        
        return (int)$customerExist['exist'];
    }


    /**
    * Inicio de sesion de customer
    * @param String $email, $password
    * @return array
    */
    public function login($email, $password){
        $sql = '
            SELECT c.va_customer_id
            FROM `va_customer` c 
            WHERE c.va_customer_email = "'.$email.'"
                AND c.va_customer_pass = "'.$password.'"
                AND c.va_customer_status = 1
        ';

        $rs = $this->tableGateway->getAdapter()->driver->getConnection()->execute($sql);
        $login = $rs->current();
        
        return (int)$login['va_customer_id'];
    }


    /**
    * Valida que venga el api key y que sea correcto
    * @param String $apiKey
    * @return array
    */
    public function validateApiKey($apiKey){
        $sql = '
            SELECT COUNT(*) AS exist
            FROM `va_customer` c 
            WHERE md5(CONCAT("", c.va_customer_email)) = "'.$apiKey.'"
        ';

        $rs = $this->tableGateway->getAdapter()->driver->getConnection()->execute($sql);
        
        return $rs->current();
    }

    
}