<?php

namespace Application\Model;
use Zend\Db\Adapter\Adapter;

use Zend\Db\Sql\Sql;
date_default_timezone_set('America/Mexico_City');


class Dbquery {

	private $db;//DB Adapter

	private $config;
	public $SITE_URL;
	public $BASE_PATH;
	private $now;
	private $tools;
	public $WS_NOTIFICATIONS_ADDRESS;
	public $WS_NOTIFICATIONS_PORT;
	public $WS_PUBLISHER_TOKEN;
	public $WS_PUBLISHER_ID;

	public function __construct($dbAdapter, $config, $tools) {
		$this->db                      = $dbAdapter;
		$this->config                  = $config;
		$this->tools                   = $tools;
		$this->now                     = date("Y-m-d H:i:s");
		$this->SITE_URL                = $this->config['layout']['SITE_URL'];
		$this->BASE_PATH               = $this->config['server']['BASE_PATH'];
		$this->WS_NOTIFICATIONS_ADDRESS  = $this->config['ws']['WS_NOTIFICATIONS_ADDRESS'];
		$this->WS_NOTIFICATIONS_PORT     = $this->config['ws']['WS_NOTIFICATIONS_PORT'];
		$this->WS_PUBLISHER_TOKEN        = $this->config['ws']['WS_PUBLISHER_TOKEN'];
		$this->WS_PUBLISHER_ID           = $this->config['ws']['WS_PUBLISHER_ID'];
		
	}
	
	public function getDbquery(){
		return $this->db;
	}
	
	public function login($email, $pass) {
		
		$result = $this->db->query('SELECT
										va_users_id AS users_id,
										va_users_fullname AS users_fullname,
										va_users_email AS users_email,
										va_users_avatar AS users_avatar,
										va_users_status AS users_status
									FROM va_users
									WHERE va_users_email = ?
									AND va_users_password = ?
									AND va_users_status = 1',
			array($email, md5($pass.$this->config['pass']['concat'])));

		$user = $result->toArray();
		//Debug::dump($user);
		return $user;
	}

	/**
	* Retorna el listado de ciudades activas
	* @return array
	*/
	public function getCitiesList() {
		$sql = 'SELECT va_city_id AS cityId, va_city_name AS cityName 
			FROM va_city 
			WHERE va_city_status = 1 AND va_city_id <> 1';
		$rs = $this->db->query($sql, array());
		return $rs->toArray();
	}

	/**
	* Retorna row de va_requeststatus
	* @return array
	*/
	public function getRequestStatusById($statusId){
		$sql = 'SELECT * 
			FROM va_requeststatus
			WHERE va_requeststatus_id = ' . $statusId;
		$rs = $this->db->query($sql, array());
		return $rs->toArray();
	}
}