<?php

namespace Application\Model;
use Zend\Db\Adapter\Adapter;
use Zend\Debug\Debug;
use Zend\Db\Sql\Sql;

class Landing {

	private $db;
	private $config;
	public $SITE_URL;
	private $now;

	public function __construct($sm) {
		$this->db                      = $sm->get('Zend\Db\Adapter\Adapter');
		$this->config                  = $sm->get('Config');
		$this->now                     = date("Y-m-d H:i:s");
		$this->SITE_URL                = $this->config['layout']['SITE_URL'];
	}
	
	public function create($newData = array()){
		$sql = new Sql($this->db);
		
		$insert = $sql->insert('as_landingpage');
		$newData = array(
			'as_landingpage_id' => null,
			'as_landingpage_url' => $newData['url'],
			'as_landingpage_titulo' => $newData['titulo'],
			'as_landingpage_subtitulo' => $newData['subtitulo'],
			'as_landingpage_texto1' => $newData['texto1'],
			'as_landingpage_texto2' => $newData['texto2'],
			'as_landingpage_condiciones' => $newData['condiciones'],
			//'as_landingpage_img1' => $newData['titulo'],
			//'as_landingpage_img2' => $newData['titulo'],
			'as_landingpage_estatus' => $newData['estatus']
		);
		//Debug::dump($newData);
		$insert->values($newData);
		
		$selectString = $sql->getSqlStringForSqlObject($insert);
		
		$results = $this->db->query($selectString, Adapter::QUERY_MODE_EXECUTE);
		
		if ($results) {
			return $this->db->getDriver()->getLastGeneratedValue();
		} else {
			return $results;
		}
	}
	
	
	
	public function update($data){
		
		if(isset($data["id"])){
			
			$newData = array(
				'as_landingpage_url' => $data['url'],
				'as_landingpage_titulo' => $data['titulo'],
				'as_landingpage_subtitulo' => $data['subtitulo'],
				'as_landingpage_texto1' => $data['texto1'],
				'as_landingpage_texto2' => $data['texto2'],
				'as_landingpage_condiciones' => $data['condiciones'],
				'as_landingpage_estatus' => $data['estatus']
			);
			
			
			$sql = new Sql($this->db);
			$update = $sql->update('as_landingpage');
			
			$update->set($newData);
			$update->where('as_landingpage_id = '.$data['id']);
			$selectString = $sql->getSqlStringForSqlObject($update);
			$resultUpdate = $this->db->query($selectString, Adapter::QUERY_MODE_EXECUTE);

			return $resultUpdate;
		}else{
			return false;
		}
	}

	public function updateImages($data, $id){
		if(count($data) > 0 && is_numeric($id)){
			$sql = new Sql($this->db);
			$update = $sql->update('as_landingpage');
			
			$update->set($data);
			$update->where('as_landingpage_id = '.$id);
			$selectString = $sql->getSqlStringForSqlObject($update);
			$resultUpdate = $this->db->query($selectString, Adapter::QUERY_MODE_EXECUTE);

			return $resultUpdate;
		}else{
			return false;
		}
	}


	public function editProject(
			$ct_project_id=0, 
			$ct_project_name="",
			$ct_project_desc="",
			$ct_project_req="",
			$ct_project_color="",
			$ct_project_estimatedtimeauto=1,
			$ct_project_manualestimatedtime="00:00:00",
			$ct_client_id=0,
			$ct_project_visibilitytype="Team",
			$ct_project_billable=1,
			$ct_project_billableamount=0,
			$ct_project_currency="USD"
	){
		
		
		if($ct_project_id != 0){
			
			
			$newData = array(
				'ct_project_name' => $ct_project_name,
				'ct_project_desc' => $ct_project_desc,
				'ct_project_req' => $ct_project_req,
				'ct_project_color' => $ct_project_color,
				'ct_project_estimatedtimeauto' => $ct_project_estimatedtimeauto,
				'ct_project_manualestimatedtime' => $ct_project_manualestimatedtime,
				'ct_client_id' => $ct_client_id,
				'ct_project_visibilitytype' => $ct_project_visibilitytype,
				'ct_project_billable' => $ct_project_billable,
				'ct_project_billableamount' => $ct_project_billableamount,
				'ct_project_currency' => $ct_project_currency
			);
			
			
			
			$sql = new Sql($this->db);
			$update = $sql->update('ct_project');
			
			
			$update->set($newData);
			$update->where('ct_project_id = '.$ct_project_id);
			$selectString = $sql->getSqlStringForSqlObject($update);
			$resultUpdate = $this->db->query($selectString, Adapter::QUERY_MODE_EXECUTE);
			return $resultUpdate;
		}else{
			return false;
		}
	}
	
	public function getLandingPage($as_landingpage_id){
		
		$result = $this->db->query('SELECT
									lp.*
									FROM as_landingpage lp
									WHERE lp.as_landingpage_id = ?',array($as_landingpage_id));
		$arrayResult = $result->toArray();
		//Debug::dump($arrayResult);
		return $arrayResult;
		
	}
	
	public function getLandingPagesList(){
		
		$result = $this->db->query('SELECT
									lp.*
									FROM as_landingpage lp
									ORDER BY as_landingpage_id DESC',array());
		$arrayResult = $result->toArray();
		//Debug::dump($arrayResult);
		return $arrayResult;
		
	}

}