<?php 
namespace Application\Model;


use Zend\Db\TableGateway\TableGateway;


class LandingTable
{
    protected $tableGateway;

    //https://framework.zend.com/manual/2.0/en/user-guide/database-and-models.html
    //Aca la documentación para ejemplos
    public function __construct(TableGateway $tableGateway)
    {
        $this->tableGateway = $tableGateway;
    }


    public function fetchAll()
    {
        $resultSet = $this->tableGateway->select();
        return $resultSet;
    }

    public function save($_data)
    {
        if (!isset($_data["va_event_id"])) {
            $this->tableGateway->insert($_data);
            return $this->tableGateway->lastInsertValue;
            
        } else {
            /*if ($this->getOrder($_data["nj_orders_id"])) {
                return $this->tableGateway->update($_data, array('nj_orders_id' => $_data["nj_orders_id"]));
            } else {
                throw new \Exception('Order nj_orders_id does not exist');
            }*/
            return false;
        }
        
    }

    /**
    * Return Int //Afected rows total
    */
    public function update($data, $conditions){
        if(!is_array($conditions)){
            return 0;
        }
        return $this->tableGateway->update($data, $conditions);
    }


    public function getRequestsByDate($date = null){
        if($date == null){
            $date = date('Y-m-d');
        }

        $sql = "
            SELECT 
                r.va_request_id,
                r.va_request_datetime,
                r.va_request_cost,
                r.va_request_acceptedtime,
                ci.va_city_id,
                ci.va_city_name,
                c.va_customer_id,
                c.va_customer_name,
                c.va_customer_lastname,
                c.va_customer_secondlastname,
                r.va_request_appstotal,
                a.va_app_id,
                a.va_app_name,
                v.va_vehicletype_name,
                rs.va_requeststatus_id,
                rs.va_requeststatus_name 
            FROM va_request r 
                INNER JOIN va_customer c ON r.va_customer_id = c.va_customer_id 
                INNER JOIN va_city ci ON c.va_city_id = ci.va_city_id 
                INNER JOIN va_vehicletype v ON v.va_vehicletype_id = r.va_vehicletype_id 
                INNER JOIN va_app a ON v.va_app_id = a.va_app_id 
                INNER JOIN va_requeststatus rs ON r.va_requeststatus_id = rs.va_requeststatus_id 
            WHERE DATE(r.va_request_datetime) = DATE('".$date."') 
            ORDER BY r.va_request_id DESC
        ";

        $rs = $this->tableGateway->getAdapter()->driver->getConnection()->execute($sql);
        
        return $rs->allData();
    }

    public function getLandingPage($requestId){
        if(!is_numeric($requestId)){
            return false;
        }

        $sql = "
            SELECT 
                r.va_request_id,
                r.va_request_datetime,
                r.va_request_cost,
                r.va_request_acceptedtime,
                ci.va_city_id,
                ci.va_city_name,
                c.va_customer_id,
                c.va_customer_name,
                c.va_customer_lastname,
                c.va_customer_secondlastname,
                r.va_request_appstotal,
                a.va_app_id,
                a.va_app_name,
                v.va_vehicletype_name,
                rs.va_requeststatus_id,
                rs.va_requeststatus_name 
            FROM va_request r 
                INNER JOIN va_customer c ON r.va_customer_id = c.va_customer_id 
                INNER JOIN va_city ci ON c.va_city_id = ci.va_city_id 
                INNER JOIN va_vehicletype v ON v.va_vehicletype_id = r.va_vehicletype_id 
                INNER JOIN va_app a ON v.va_app_id = a.va_app_id 
                INNER JOIN va_requeststatus rs ON r.va_requeststatus_id = rs.va_requeststatus_id 
            WHERE r.va_request_id = '".$requestId."'
        ";

        $rs = $this->tableGateway->getAdapter()->driver->getConnection()->execute($sql);
        
        return $rs->current();
    }
    
}