<?php
namespace Application\Plugin;
 
use Zend\Mvc\Controller\Plugin\AbstractPlugin;
use Zend\Session\Container;
use Zend\Debug\Debug;
use Zend\Mvc\Controller\AbstractActionController;
use Zend\View\Model\ViewModel;
use Zend\View\Renderer\PhpRenderer;
use Zend\View\Resolver;
use Zend\Mail;
use Zend\xmlrpc;
use zendxml;
use Zend\Mime\Part as MimePart;
use Zend\Mime\Message as MimeMessage;
//use SimpleXMLElement;
use DOMDocument;
use XSLTProcessor;
use DateTime;


class Tools extends AbstractPlugin{

	protected $config = null;

	public function _config(){
        if(is_null($this->config)){
            $this->config = json_decode(json_encode($this->getController()->getServiceLocator()->get('Config')));
        }
        return $this->config;
    }


	public function sellarXML($cfdi, $numero_certificado, $archivo_cer, $archivo_pem, $cadenaoriginal_3_2){
	//public function sellarXML($cfdi){

	
		$private = openssl_pkey_get_private(file_get_contents($archivo_pem));
		$certificado = str_replace(array('\n', '\r'), '', base64_encode(file_get_contents($archivo_cer)));
		$xdoc = new DomDocument();
		$xdoc->loadXML($cfdi) or die("XML invalido");

		$XSL = new DOMDocument();
		/*
		echo "<pre>";
		print_r($xdoc);
		echo "</pre>";
		die("qqq");*/
		
		$XSL->load($cadenaoriginal_3_2);
		
		$proc = new XSLTProcessor;
		$proc->importStyleSheet($XSL);
		$cadena_original = $proc->transformToXML($xdoc);
		openssl_pkcs12_read($cadena_original, $sig, $private);
		$sello = base64_encode($sig);
		$c = $xdoc->getElementsByTagNameNS('http://www.sat.gob.mx/cfd/3', 'Comprobante')->item(0); 
		$c->setAttribute('sello', $sello);
		$c->setAttribute('certificado', $certificado);
		$c->setAttribute('noCertificado', $numero_certificado);
		
		/*
		$root = new SimpleXMLElement($c);
		$root->asXml('Juan.xml');*/
		
		return $xdoc->saveXML();
		


	}

	public function in_multiarray($elem='', $array=array())
	{
        if(is_array($array)){
            foreach($array as $key => $value)
            {
                if($array[$key] == $elem)
                    return true;
                else 
                    if(is_array($array[$key]))
                        if($this->in_multiarray($elem, ($array[$key])))
                            return true;
            }
        }
		
		return false;
	}

	public function log($content=null, $useDate=true, $newPrefix=''){
		if($content == null) return false;
		$content = print_r($content, true);
		$dbquery = $this->getController()->getServiceLocator()->get('Application/Model/Dbquery');
		$path = $dbquery->BASE_PATH.'/var/log/';
		
		
		
		//$path = 'log/';
		if($newPrefix != ''){
			$prefix = $newPrefix;
		}else{
			$prefix = 'system';
		}
		$file = $prefix.($useDate?'_'.date("Ymd"):'').'.log';
			if (!$gestor = fopen($path.$file, 'a')) {
				 //echo "No se puede abrir el archivo ($file)";
				 exit;
			}
			$content .= "\r\n";
			$content = date("Y-m-d H:i:s").' : '.$content;
			// Escribir $content a nuestro archivo abierto.
			if (fwrite($gestor, $content) === FALSE) {
				//echo "No se puede escribir en el archivo ($file)";
				exit;
			}
			//echo "éxito, se escribió ($content) en el archivo ($file)";
			fclose($gestor);
	}
	
	
	public function downloadFile($file){
		
		if (file_exists($file)) {
				header('Content-Description: File Transfer');
				header('Content-Type: application/octet-stream');
				header('Content-Disposition: attachment; filename='.basename($file));
				header('Content-Transfer-Encoding: binary');
				header('Expires: 0');
				header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
				header('Pragma: public');
				header('Content-Length: ' . filesize($file));
				ob_clean();
				flush();
				readfile($file);
				exit;
		}else{
			
			return false;
		}
	
	}

	public function createCsv($rows, $fileName = ""){
		if($fileName == ''){
			$filename = "export_" . date('Y-m-d');
		}
		$headers = array();

		header("Content-type: application/csv");
        header("Content-Disposition: attachment; filename=".$fileName.".csv");
        header("Pragma: no-cache");
        header("Expires: 0");

        $fp = fopen('php://output', 'w');

        if(is_array($rows) && count($rows) > 0){
        //Crear cabeceras
	        foreach ($rows as $row) {
	        	$headers = array_keys($row); 
	        	break;
	        }        
	        //Colocar cabeceras en CSV
	        fputcsv($fp, $headers);

	        //Recorrer filas
	        foreach ($rows as $row) {
	        	$cells = array();

	        	//Recorrer columnas
	        	foreach ($row as $cell) {
	        		$cells[] = $cell;        
	        	}

	        	fputcsv($fp, $cells);		
	        }
	        
        }//End if

        fclose($fp);

        return $fp;
	}
	
	public function GetTimeDiff($timestamp){
	
		$how_log_ago = '';
		$seconds = time() - $timestamp; 
		$minutes = (int)($seconds / 60);
		$hours = (int)($minutes / 60);
		$days = (int)($hours / 24);
		if ($days >= 1) {
		  $how_log_ago = $days . ' day' . ($days != 1 ? 's' : '');
		} else if ($hours >= 1) {
		  $how_log_ago = $hours . ' hour' . ($hours != 1 ? 's' : '');
		} else if ($minutes >= 1) {
		  $how_log_ago = $minutes . ' minute' . ($minutes != 1 ? 's' : '');
		} else {
		  $how_log_ago = $seconds . ' second' . ($seconds != 1 ? 's' : '');
		}
		return $how_log_ago;
	}
	
	public function hasAccess($resource='nada')
	{
		$userSessionAuth = new Container('userSessionAuth');
		$permissions = $userSessionAuth->offsetGet('permissions');
		
		//Debug::dump($permissions);
		if($this->in_multiarray('nada', $permissions)){
			return false;
		}
		if($this->in_multiarray('todo', $permissions)){
			return true;
		}
		return $this->in_multiarray($resource, $permissions);
	}


	public function Email($to='test@desarrollodigital.net', $toName='Luis Aguilar', $toBcc="bcc@desarrollodigital.net", $subject="Ninja Notification", $templateName='test', $templateVars=array('foo'=>'var'), $cron=false){
	
		if(getenv("APPLICATION_ENV") == "staging"){
			$options = new Mail\Transport\SmtpOptions(array( 
                'name' => 'staging.ninja.enviodivino.com',  
                'host' => 'staging.ninja.enviodivino.com',  
                'port'=> 587, 
                'connection_class' => 'login',  
                'connection_config' => array(  
                    'username' => 'test@staging.ninja.enviodivino.com', 
                    'password' => 'akdomad^GE!o', 
                    // 'ssl'=> 'tls',  
                ),
            ));
		}else{
            $options = new Mail\Transport\SmtpOptions(array( 
                'name' => 'staging.ninja.enviodivino.com',  
                'host' => 'staging.ninja.enviodivino.com',  
                'port'=> 587, 
                'connection_class' => 'login',  
                'connection_config' => array(  
                    'username' => 'test@staging.ninja.enviodivino.com', 
                    'password' => 'akdomad^GE!o', 
                    // 'ssl'=> 'tls',  
                ),
            ));
        }
        
        

        
		
		if($cron == true){
			
			$basePath = realpath(__DIR__ .'/../../../view/email/templates');
			//$htmlFilename = 'MensajerosSinComunicacionBusy.phtml';
			//$txtFilename = 'body.txt.phtml';
			$renderer = new PhpRenderer();
			$renderer->resolver()->addPath($basePath);
			$model = new ViewModel();
			
			foreach($templateVars as $key=>$val){
				$model->setVariable($key, $val);
			}
			
			//$model->setTemplate($txtFilename);
			//$textContent = $renderer->render($model);
			$model->setTemplate($templateName);
			$content = $renderer->render($model);
			
		}else{
			$this->renderer = $this->getController()->getServiceLocator()->get('ViewRenderer'); 
			$content = $this->renderer->render('/email/templates/'.$templateName, $templateVars);
		}
		//
		
		
		
		// make a header as html  
		$html = new MimePart($content);  
		$html->type = "text/html";  
		$body = new MimeMessage();  
		$body->setParts(array($html,));  
		
		// instance mail   
		$mail = new Mail\Message();  
		$mail->setBody($body); // will generate our code html from template.phtml  
		$mail->setFrom('test@staging.ninja.enviodivino.com','ninja test');  
		$mail->setEncoding("UTF-8");
		$mail->setTo($to, $toName);
		//if($toBcc != "")	$mail->setBcc($toBcc);
		$mail->setSubject($subject); 
        
        
		
		$transport = new Mail\Transport\Smtp($options);  
		 
		
		
		try {
			$transport->send($mail);
			$sent = true; 
		} catch (Exception $e){
			$sent = false;
		}
		return $sent;
		
	}

	public function preRenderView($varsToView = array(), $template = null){
		
		//----------------------------------------//
		ob_end_clean();
		header("Connection: close");
		ignore_user_abort(); //optional
		ob_start();
		//----------------------------------------//
		
		$viewModel = new ViewModel($varsToView);
		$view = strtolower($this->getController()->getEvent()->getRouteMatch()->getParam('action', 'index'));
		$controller = strtolower($this->getController()->params('controller'));
		$explode = explode('\\', $controller);
		$controller = array_pop($explode);
		//echo "controllerrr: ".$controller;
		if($template == null){
			$viewModel->setTemplate('application/'.$controller.'/'.$view.'.phtml');
		}
		else{
			$viewModel->setTemplate($template);
		}
		//$viewModel->setTemplate('application/test/wstests');//Funciona de cualquier manera
		$viewRender = $this->getController()->getServiceLocator()->get('ViewRenderer');
		$html = $viewRender->render($viewModel);
		echo $html;
		
		//----------------------------------------//
		$size = ob_get_length();
		header("Content-Length: $size");
		ob_end_flush(); // Strange behaviour, will not work
		flush();            // Unless both are called !
		session_write_close(); // Added a line suggested in the comment
		//----------------------------------------//
		
	}

	/**
	* Verifica que el Api key sea válido
	* @param Array $params 
	* @return Array 
	*/

	function validateApiKey($params){
		$resp = array('response' => false , 'message' => 'nothing');

		if(isset($params['apiKey']) && $params['apiKey'] != ''){
			$validateApiKey = $this->getController()->getServiceLocator()
				->get('Application/Model/CustomerTable')
				->validateApiKey($params['apiKey']);

			if((int)$validateApiKey['exist']){
				$resp['response'] = true;
				$resp['message'] = 'Api Key Correcto';
			}
			else{
				$resp['message'] = 'Api Key Incorrecto';
			}
		}
		else{
			$resp['message'] = 'Falta apiKey';
		}

		return $resp;
	}
	
	public function getSlashParams($slashParams=""){
		
		if($slashParams==""){
			return false;
		}
		
		$params = explode("/", $slashParams);
		$associativeParams = array();
		for($i=0;$i<count($params);$i+=2){
			if(isset($params[$i]) && $params[$i]!==""){
				$associativeParams[$params[$i]] = isset($params[$i+1])?$params[$i+1]:null;
			}else{
				break;
			}
		}
		return $associativeParams;
	}
    
}