var WS_NOTIFICATIONS_ADDRESS;
var WS_NOTIFICATIONS_PORT;
var WS_MODULE;
var ws;
var reconnectTimer = null;

function wsSetGlbs(){
    WS_NOTIFICATIONS_ADDRESS = jQuery("body").attr("data-wsaddress");
    WS_NOTIFICATIONS_PORT = jQuery("body").attr("data-wsport");
    WS_MODULE = jQuery("#wsModule").attr('data-wsmodule');

    console.log("ws module: " + WS_MODULE);
}

function wsReconnect(){
    if(ws == null){
        if(reconnectTimer == null){
            //con.log("wsReconnect Reconnecting in 30 secs...");
            reconnectTimer = setInterval(function(){
                initNotifications();
            }, 15000);
        }else{
            //con.log("wsReconnect reconnectTimer current active.");
            
        }
    }else{
        clearInterval(reconnectTimer);
        //con.log("wsReconnect clearInterval.");
    }
}

function initNotifications(){
    try{
        ws = new WebSocket("ws://" + WS_NOTIFICATIONS_ADDRESS + ":" + WS_NOTIFICATIONS_PORT + "/ws?type=customer&customerId=888&module=" + WS_MODULE);

        ws.onopen = function () {
            //console.log("Ws status: " + this.readyState);
            if(reconnectTimer != null && this.readyState == 1){
                clearInterval(reconnectTimer);
                reconnectTimer = null;
            }
        };
        ws.onmessage = function (ev) {
            console.log(ev.data);
            
            if(ev.data.indexOf("fileno|") == -1){
                var jsonData = jQuery.parseJSON( ev.data );
                wsEvents(jsonData);
            }
            
        };
        ws.onclose = function (ev) {
            console.log("Ws Disconnected - status: " + this.readyState);
            ws = null;
            wsReconnect();
        };
        ws.onerror = function (ev) {
            console.log("Ws error" + ev.getMessage());
        };
    }catch(ex){
        console.log(ex);
        wsReconnect();
    }
}

$(document).ready(function(){
    wsSetGlbs();
    initNotifications();
});